#include "Datenbank.h"
#include <Zeit.h>

// Inhalt der LSDatenbank Klasse aus Datenbank.h
// Konstruktor
KSDatenbank::KSDatenbank( InitDatei *zIni )
{
    if( !zIni->wertExistiert( "DBBenutzer" ) )
        zIni->addWert( "DBBenutzer", "kartenserveru" );
    if( !zIni->wertExistiert( "DBPasswort" ) )
        zIni->addWert( "DBPasswort", "LTKitorServerPW" );
    if( !zIni->wertExistiert( "DBName" ) )
        zIni->addWert( "DBName", "koljadb" );
    if( !zIni->wertExistiert( "DBIP" ) )
        zIni->addWert( "DBIP", "127.0.0.1" );
    if( !zIni->wertExistiert( "DBPort" ) )
        zIni->addWert( "DBPort", "5432" );
    datenbank = new Datenbank( zIni->zWert( "DBBenutzer" )->getText(), zIni->zWert( "DBPasswort" )->getText(),
                               zIni->zWert( "DBName" )->getText(), zIni->zWert( "DBIP" )->getText(),
                               (unsigned short)TextZuInt( zIni->zWert( "DBPort" )->getText(), 10 ) );
    InitializeCriticalSection( &cs );
    ref = 1;
}

// Destruktor
KSDatenbank::~KSDatenbank()
{
    datenbank->release();
    DeleteCriticalSection( &cs );
}

// nicht constant
void KSDatenbank::lock()
{
    EnterCriticalSection( &cs );
}

void KSDatenbank::unlock()
{
    LeaveCriticalSection( &cs );
}

int KSDatenbank::istAdministrator( const char *name, const char *passwort )
{
    Text *befehl = new Text( "SELECT id FROM benutzer WHERE name = '" );
    befehl->append( name );
    befehl->append( "' AND passwort = '" );
    befehl->append( passwort );
    befehl->append( "'" );
    lock();
    datenbank->befehl( befehl->getText() );
    Result res = datenbank->getResult();
    unlock();
    befehl->release();
    int ret = 0;
    if( res.zeilenAnzahl > 0 )
        ret = TextZuInt( res.values[ 0 ].getText(), 10 );
    res.destroy();
    return ret;
}

bool KSDatenbank::adminHatRecht( int id, int recht )
{
    Text *befehl = new Text( "SELECT * FROM benutzer_rechte WHERE benutzer_id = " );
    befehl->append( id );
    befehl->append( " AND rechte_id = " );
    befehl->append( recht );
    lock();
    datenbank->befehl( befehl->getText() );
    int ret = datenbank->getZeilenAnzahl();
    unlock();
    befehl->release();
    return ret != 0;
}

bool KSDatenbank::proveKlient( int num, int sNum )
{
    Text *befehl = new Text( "SELECT * FROM server_karten_clients WHERE server_karten_id = " );
    befehl->append( sNum );
    befehl->append( " AND client_id = " );
    befehl->append( num );
    lock();
    datenbank->befehl( befehl->getText() );
    Result res = datenbank->getResult();
    unlock();
    befehl->release();
    bool ret = 0;
    if( res.zeilenAnzahl == 1 )
        ret = 1;
    res.destroy();
    return ret;
}

Text *KSDatenbank::getKlientKey( int cId )
{
    lock();
    if( !datenbank->befehl( Text( "SELECT schluessel FROM clients WHERE id = " ) += cId ) )
    {
        unlock();
        return 0;
    }
    Result res = datenbank->getResult();
    unlock();
    if( !res.zeilenAnzahl )
    {
        res.destroy();
        return 0;
    }
    Text *ret = new Text( res.values[ 0 ].getText() );
    res.destroy();
    return ret;
}

void KSDatenbank::unregisterKlient( int num, int sNum )
{
    Text *befehl = new Text( "DELETE FROM server_karten_clients WHERE client_id = " );
    befehl->append( num );
    befehl->append( " AND server_karten_id = " );
    befehl->append( sNum );
    lock();
    datenbank->befehl( befehl->getText() );
    unlock();
    befehl->release();
}

bool KSDatenbank::serverAnmelden( InitDatei *zIni )
{
    if( !zIni->wertExistiert( "ServerId" ) )
        zIni->addWert( "ServerId", "0" );
    if( !zIni->wertExistiert( "ServerName" ) )
        zIni->addWert( "ServerName", "Name" );
    if( !zIni->wertExistiert( "ServerPort" ) )
        zIni->addWert( "ServerPort", "49144" );
    if( !zIni->wertExistiert( "ServerIP" ) )
        zIni->addWert( "ServerIP", "127.0.0.1" );
    if( !zIni->wertExistiert( "AdminServerPort" ) )
        zIni->addWert( "AdminServerPort", "49143" );
    if( !zIni->wertExistiert( "Aktiv" ) )
        zIni->addWert( "Aktiv", "FALSE" );
    if( !zIni->wertExistiert( "MaxKarten" ) )
        zIni->addWert( "MaxKarten", "50" );
    bool insert = 0;
    int id = *zIni->zWert( "ServerId" );
    if( id )
    {
        lock();
        if( !datenbank->befehl( Text( "SELECT id FROM server_karten WHERE id = " ) += id ) )
        {
            unlock();
            return 0;
        }
        int anz = datenbank->getZeilenAnzahl();
        unlock();
        insert = anz == 0;
        if( !insert )
        {
            lock();
            if( !datenbank->befehl( Text( "SELECT id FROM server_karten WHERE server_status_id = 1 AND id = " ) += id ) )
            {
                unlock();
                return 0;
            }
            int anz = datenbank->getZeilenAnzahl();
            unlock();
            if( !anz ) // Server luft bereits
                return 0;
        }
    }
    if( insert || !id )
    { // Neuer Eintrag in Tabelle server_karten
        Text *befehl = new Text( "INSERT INTO server_karten( " );
        if( id )
            *befehl += "id, ";
        *befehl += "name, ip, port, admin_port, server_status_id, max_karten ) VALUES( ";
        if( id )
        {
            *befehl += id;
            *befehl += ", ";
        }
        *befehl += "'";
        *befehl += zIni->zWert( "ServerName" )->getText();
        *befehl += "', '";
        *befehl += zIni->zWert( "ServerIP" )->getText();
        *befehl += "', ";
        *befehl += zIni->zWert( "ServerPort" )->getText();
        *befehl += ", ";
        *befehl += zIni->zWert( "AdminServerPort" )->getText();
        *befehl += ", 1, ";
        *befehl += zIni->zWert( "MaxKarten" )->getText();
        *befehl += " ) RETURNING id";
        lock();
        if( !datenbank->befehl( *befehl ) )
        {
            unlock();
            befehl->release();
            return 0;
        }
        Result res = datenbank->getResult();
        unlock();
        befehl->release();
        if( !res.zeilenAnzahl )
        {
            res.destroy();
            return 0;
        }
        zIni->setWert( "ServerId", res.values[ 0 ] );
        return 1;
    }
    else
    { // Alten Eintrag aus Tabelle server_karten ndern
        Text *befehl = new Text( "UPDATE server_karten SET name = '" );
        *befehl += zIni->zWert( "ServerName" )->getText();
        *befehl += "', port = ";
        *befehl += zIni->zWert( "ServerPort" )->getText();
        *befehl += ", ip = '";
        *befehl += zIni->zWert( "ServerIP" )->getText();
        *befehl += "', max_karten = ";
        *befehl += zIni->zWert( "MaxKarten" )->getText();
        *befehl += ", admin_port = ";
        *befehl += zIni->zWert( "AdminServerPort" )->getText();
        *befehl += " WHERE id = ";
        *befehl += id;
        lock();
        bool ret = datenbank->befehl( *befehl );
        unlock();
        befehl->release();
        return ret;
    }
}

bool KSDatenbank::setServerStatus( int id, int status )
{
    Text *befehl = new Text( "UPDATE server_karten SET server_status_id = " );
    *befehl += status;
    *befehl += "WHERE id = ";
    *befehl += id;
    lock();
    if( !datenbank->befehl( befehl->getText() ) )
    {
        unlock();
        befehl->release();
        return 0;
    }
    bool ret = datenbank->getZeilenAnzahl() != 0;
    unlock();
    befehl->release();
    return ret;
}

bool KSDatenbank::setMaxKarten( int id, int maxK )
{
    Text *befehl = new Text( "UPDATE server_karten SET max_karten = " );
    befehl->append( maxK );
    befehl->append( " WHERE id = " );
    befehl->append( id );
    lock();
    if( !datenbank->befehl( befehl->getText() ) )
    {
        unlock();
        befehl->release();
        return 0;
    }
    bool ret = datenbank->getZeilenAnzahl() > 0;
    unlock();
    befehl->release();
    return ret;
}

int KSDatenbank::getAdminPort( int id )
{
    Text *befehl = new Text( "SELECT admin_port FROM server_karten WHERE id = " );
    befehl->append( id );
    lock();
    if( !datenbank->befehl( befehl->getText() ) )
    {
        unlock();
        befehl->release();
        return 0;
    }
    Result res = datenbank->getResult();
    unlock();
    befehl->release();
    if( !res.zeilenAnzahl )
    {
        res.destroy();
        return 0;
    }
    int ret = TextZuInt( res.values[ 0 ].getText(), 10 );
    res.destroy();
    return ret;
}

bool KSDatenbank::serverIstNichtPausiert( int id )
{
    Text *befehl = new Text( "SELECT server_status_id FROM server_karten WHERE id = " );
    befehl->append( id );
    lock();
    if( !datenbank->befehl( befehl->getText() ) )
    {
        unlock();
        befehl->release();
        return 0;
    }
    Result res = datenbank->getResult();
    unlock();
    befehl->release();
    if( !res.zeilenAnzahl )
    {
        res.destroy();
        return 0;
    }
    bool ret = (int)res.values[ 0 ] == 3;
    res.destroy();
    return ret;
}

bool KSDatenbank::proveKarte( int id, int sNum )
{
    Text befehl = "SELECT id FROM karte WHERE id = ";
    befehl += id;
    befehl += " AND server_karten_id = ";
    befehl += sNum;
    lock();
    if( !datenbank->befehl( befehl ) )
    {
        unlock();
        return 0;
    }
    bool ret = datenbank->getZeilenAnzahl() != 0;
    unlock();
    return ret;
}

int KSDatenbank::getUpdateKarte( int serverId )
{
    Text befehl = "SELECT id FROM karte WHERE erlaubt = FALSE AND server_karten_id = ";
    befehl += serverId;
    lock();
    if( !datenbank->befehl( befehl ) )
    {
        unlock();
        return 0;
    }
    Result r = datenbank->getResult();
    unlock();
    for( int i = 0; i < r.zeilenAnzahl; i++ )
    {
        int karte = r.values[ i ];
        befehl = "SELECT karte_update_warten( ";
        befehl += karte;
        befehl += " )";
        lock();
        if( !datenbank->befehl( befehl ) )
        {
            unlock();
            continue;
        }
        Result res = datenbank->getResult();
        unlock();
        if( !res.zeilenAnzahl )
        {
            res.destroy();
            continue;
        }
        if( res.values[ 0 ].istGleich( "f" ) )
        {
            res.destroy();
            r.destroy();
            return karte;
        }
        res.destroy();
    }
    r.destroy();
    return 0;
}

bool KSDatenbank::endUpdateKarte( int karteId )
{
    Text befehl = "SELECT karte_update_ende( ";
    befehl += karteId;
    befehl += " )";
    lock();
    if( !datenbank->befehl( befehl ) )
    {
        unlock();
        return 0;
    }
    Result r = datenbank->getResult();
    unlock();
    if( !r.zeilenAnzahl )
    {
        r.destroy();
        return 0;
    }
    bool ret = r.values[ 0 ].istGleich( "t" );
    r.destroy();
    return ret;
}

bool KSDatenbank::getEditorServerPortIp( int karteId, int *port, Text *ip )
{
    if( !port || !ip )
        return 0;
    Text befehl = "SELECT a.port, a.ip FROM server_editor a, karte b WHERE a.id = b.server_editor_id AND b.id = ";
    befehl += karteId;
    lock();
    if( !datenbank->befehl( befehl ) )
    {
        unlock();
        return 0;
    }
    Result r = datenbank->getResult();
    unlock();
    if( !r.zeilenAnzahl )
    {
        r.destroy();
        return 0;
    }
    *port = r.values[ 0 ];
    ip->setText( r.values[ 1 ] );
    r.destroy();
    return 1;
}

bool KSDatenbank::setKarteSpielerAnzahl( int karteId, int sAnz )
{
    Text befehl = "UPDATE karte SET max_spieler = ";
    befehl += sAnz;
    befehl += " WHERE id = ";
    befehl += karteId;
    lock();
    if( !datenbank->befehl( befehl ) )
    {
        unlock();
        return 0;
    }
    int anz = datenbank->getZeilenAnzahl();
    unlock();
    if( !anz )
        return 0;
    return 1;
}

// constant
Text *KSDatenbank::getLetzterFehler() const
{
    return datenbank->getLetzterFehler();
}

// Reference Counting
KSDatenbank *KSDatenbank::getThis()
{
    ref++;
    return this;
}

KSDatenbank *KSDatenbank::release()
{
    ref--;
    if( !ref )
        delete this;
    return 0;
}