#ifdef WIN32
#include <main.h>
#endif
#include "KartenServer.h"
#include <Zeit.h>
#include <iostream>
#include <fstream>
#include <Globals.h>

#ifdef WIN32
int KSGStart Framework::Start( Startparam p )
{
#else
int main()
{
    Framework::initFramework();
#endif
	Zeit *z = getZeit();
	Text *pfad = new Text( "../log/karten/" );
	pfad->append( z->getZeit( "y-m-d h-i-s.log" ) );
	z->release();
	DateiPfadErstellen( pfad->getThis() );
	std::ofstream file;
	file.open( pfad->getText() );
	std::streambuf* sbuf = std::cout.rdbuf();
	std::cout.rdbuf( file.rdbuf() );
	pfad->release();

	std::cout << "KS: Startet...\n";
	std::cout << "KS: Lese init Datei ../data/ksInit.ini ...\n";
	InitDatei *dat = new InitDatei( "../data/ksInit.ini" );
	if( !dat->laden() )
	{
		std::cout << "KS: error: Datei konnte nicht gelesen werden. Das Programm wird geschlossen.\n";
		dat->release();
		exit( 1 );
	}

	if( dat->wertExistiert( "KartenPfad" ) )
		dat->addWert( "KartenPfad", "karten" );
	if( !DateiExistiert( dat->zWert( "KartenPfad" )->getText() ) )
	{
		Text pf = dat->zWert("KartenPfad")->getText();
		pf += "/";
		DateiPfadErstellen( pf );
	}

	KartenServer *kServer = new KartenServer( dat );

	std::cout << "KS: Der Admin Server luft. Startforgang beendet.\n";
	kServer->runn();

	kServer->ende();
	kServer->release();
	dat->speichern();
	dat->release();
	std::cout << "KS: Der Server ist heruntergefahren.\n";
	file.close();
	std::cout.rdbuf( sbuf );
#ifndef WIN32
    Framework::releaseFramework();
#endif
	return 0;
}